/*compilar usando gcc -c fichero.c*/

#include <limits.h>
#include "dinpile.h"
#include <stdlib.h>

/*Estos son las lineas estandar para cualquier tipo de datos*/
#define STDCREATECODE {\
    *pile = malloc(sizeof(STDPILE));\
    if (*pile == NULL) return 1;\
    (*pile)->elements = 0;\
    (*pile)->begin = NULL;\
    (*pile)->act = NULL;\
    return 0;\
}

#define STDPUSHCODE {\
    STDNODE *node;\
    node = malloc(sizeof(STDNODE));\
    if (node == NULL) return 1;\
    pile->elements++;\
    node->prev = pile->act;\
    node->element = element;\
    pile->act = node;\
    if(pile->elements == 1) pile->begin=pile->act;\
    return 0;\
}

#define STDPOPCODE {\
    STDNODE *node;\
    if (pile->elements == 0) return 1;\
    pile->elements--;\
    node = pile->act;\
    pile->act = node->prev;\
    free(node);\
    return 0;\
}

#define STDCIMECODE {\
    if (pile->elements == 0) return 1;\
    *out = pile->act->element;\
    return 0;\
}

#define STDEMPTYCODE {\
    if (pile->elements == 0) return 1; else return 0;\
}

/*Este código está solo para evitar avisos*/
#define STDMAXELEMENTSSETCODE {return 0;}
#define STDMAXELEMENTSGETCODE {return INT_MAX;}
#define STDRESIZECODE {return 0;}


#define STDTYPE void *
#define STDPILE dinpile
#define STDNODE dinnode
int dinpile_create (STDPILE **pile) STDCREATECODE
int dinpile_push (STDPILE *pile, STDTYPE element) STDPUSHCODE
int dinpile_pop (STDPILE *pile) STDPOPCODE
int dinpile_cime (STDPILE *pile, STDTYPE *out) STDCIMECODE
int dinpile_empty (STDPILE *pile) STDEMPTYCODE
/*Estas funciones sólo existen para evitar avisos*/
int dinpile_setmaxsize (int maxelem) STDMAXELEMENTSSETCODE
int dinpile_getmaxsize (void) STDMAXELEMENTSGETCODE
int dinpile_resize (STDPILE *pile) STDRESIZECODE
#undef STDTYPE
#undef STDPILE
#undef STDNODE

/*
#define STDTYPE void *
#define STDPILE intdinpile
#define STDNODE intdinnode
int dinpile_create (STDPILE *pile) STDCREATECODE
int dinpile_push (STDPILE *pile, STDTYPE element) STDPUSHCODE
int dinpile_pop (STDPILE *pile) STDPOPCODE
int dinpile_cime (STDPILE *pile, STDTYPE *out) STDCIMECODE
int dinpile_empty (STDPILE *pile) STDEMPTYCODE
#undef STDTYPE
#undef STDPILE
#undef STDNODE
#undef STDCREATEPILECODE
*/
/*Eliminamos las definiciones de códigos estandar por si acaso*/
#undef STDCREATECODE
#undef STDPUSHCODE
#undef STDPOPCODE
#undef STDCIMECODE
#undef STDEMPTYCODE

