/*compilar usando gcc -c fichero.c*/

#include "vectpile.h"
#include <stdlib.h>

#define STDPILEMAXELEMENTS vectpile_maxelements
/*Variable que permite cambiar el máximo de elementos en tiempo de ejecución*/
int STDPILEMAXELEMENTS = MAXELEMENTS;

/*Estos son las lineas estandar para cualquier tipo de datos*/
#define STDCREATECODE {\
    *pile = malloc(sizeof(STDPILE));\
    if (*pile == NULL) return 1;\
    (*pile)->elements = 0;\
    (*pile)->maxelements = STDPILEMAXELEMENTS;\
    if(((*pile)->act = (*pile)->all = malloc(STDPILEMAXELEMENTS * sizeof(STDTYPE))) == NULL) return 1;\
    return 0;\
}

#define STDPUSHCODE {\
    pile->elements++;\
    if (pile->elements >= pile->maxelements) { pile->elements--; return 1;}\
    *(pile->act) = element;\
    pile->act++;\
    return 0;\
}

#define STDPOPCODE {\
    if (pile->elements <= 0) return 1;\
    pile->elements--;\
    pile->act--;\
    return 0;\
}

#define STDCIMECODE {\
    if (pile->elements <= 0) return 1;\
    *out = *(pile->act-1);\
    return 0;\
}

#define STDEMPTYCODE {\
    if (pile->elements <= 0) return 1; else return 0;\
}

#define STDMAXELEMENTSSETCODE {\
    STDPILEMAXELEMENTS = maxelem;\
    return 0;\
}

#define STDMAXELEMENTSGETCODE {\
    return STDPILEMAXELEMENTS;\
}

#define STDRESIZECODE {\
    STDTYPE *secure = pile->all;\
    pile->all = realloc(pile->act, STDPILEMAXELEMENTS * sizeof(STDTYPE));\
    if (pile->all == NULL) {\
        pile->all = secure;\
        return 1;\
    }\
    pile->act = pile->elements + pile->all;\
    pile->maxelements = STDPILEMAXELEMENTS;\
    return 0;\
}


#define STDTYPE void *
#define STDPILE vectpile
#define STDPILEMAXELEMENTS vectpile_maxelements
int vectpile_create (STDPILE **pile) STDCREATECODE
int vectpile_push (STDPILE *pile, STDTYPE element) STDPUSHCODE
int vectpile_pop (STDPILE *pile) STDPOPCODE
int vectpile_cime (STDPILE *pile, STDTYPE *out) STDCIMECODE
int vectpile_empty (STDPILE *pile) STDEMPTYCODE
int vectpile_setmaxsize (int maxelem) STDMAXELEMENTSSETCODE
int vectpile_getmaxsize (void) STDMAXELEMENTSGETCODE
int vectpile_resize (STDPILE *pile) STDRESIZECODE
#undef STDTYPE
#undef STDPILE
#undef STDPILEMAXELEMENTS

/*Eliminamos las definiciones de códigos estandar por si acaso*/
#undef STDCREATECODE
#undef STDPUSHCODE
#undef STDPOPCODE
#undef STDCIMECODE
#undef STDEMPTYCODE
#undef MAXELEMENTSSET
